jQuery(document).ready(function($){
	"use strict";	
	$('#exam_form').validationEngine({promptPosition : "bottomRight",maxErrorsPerField: 1});
	 $("#exam_start_date").datepicker({
        dateFormat: "yy-mm-dd",
		minDate:0,
        onSelect: function (selected) {
            var dt = new Date(selected);
            dt.setDate(dt.getDate() + 0);
            $("#exam_end_date").datepicker("option", "minDate", dt);
        }
    });
    $("#exam_end_date").datepicker({
       dateFormat: "yy-mm-dd",
	   minDate:0,
        onSelect: function (selected) {
            var dt = new Date(selected);
            dt.setDate(dt.getDate() + 0);
            $("#exam_start_date").datepicker("option", "maxDate", dt);
        }
    });
	jQuery("body").on("change", ".input-file[type=file]", function ()
	{ 
		var file = this.files[0]; 
		var file_id = jQuery(this).attr('id'); 
		var ext = $(this).val().split('.').pop().toLowerCase(); 
		//Extension Check 
		if($.inArray(ext, ['pdf']) == -1)
		{
			  alert('Only pdf formate are allowed.');
			$(this).replaceWith('<input type="file" name="exam_syllabus" class="form-control file_validation input-file">');
			return false; 
		} 
		 //File Size Check 
		 if (file.size > 20480000) 
		 {
			alert("Too large file Size. Only file smaller than 10MB can be uploaded.");
			$(this).replaceWith('<input type="file" name="exam_syllabus" class="form-control file_validation input-file">'); 
			return false; 
		 }
	 });

	jQuery('.onlyletter_number_space_validation').on('keypress',function(e) 
	{     
		var regex = new RegExp("^[0-9a-zA-Z \b]+$");
		var key = String.fromCharCode(!event.charCode ? event.which: event.charCode);
		if (!regex.test(key)) 
		{
			event.preventDefault();
			return false;
		} 
   });

	var table =  jQuery('#exam_list').DataTable({
        responsive: true,
		"order": [[ 1, "asc" ]],
		"dom": 'Bfrtip',
		"buttons": [
			'colvis'
		], 
		"aoColumns":[	                  
	                  {"bSortable": false},
	                  {"bSortable": true},
	                  {"bSortable": true},
	                  {"bSortable": true},
	                  {"bSortable": true},
	                  {"bSortable": true},
	                  {"bSortable": true},
	                  {"bSortable": true},	                  
	                  {"bSortable": false}],
		// language:<?php echo smgt_datatable_multi_language();?>
    });
	 jQuery('#checkbox-select-all').on('click', function(){
     
      var rows = table.rows({ 'search': 'applied' }).nodes();
      jQuery('input[type="checkbox"]', rows).prop('checked', this.checked);
   }); 
   $("#delete_selected").on('click', function()
		{	
			if ($('.select-checkbox:checked').length == 0 )
			{
				alert("Please select atleast one record");
				return false;
			}
		else{
				var alert_msg=confirm("Are you sure you want to delete this record?");
				if(alert_msg == false)
				{
					return false;
				}
				else
				{
					return true;
				}
			}
	});

	$('#exam_form').validationEngine({promptPosition : "bottomRight",maxErrorsPerField: 1});
	$('#exam_form2').validationEngine({promptPosition : "bottomRight",maxErrorsPerField: 1});
	$('#exam_timelist').DataTable({
		bPaginate: false,
		bFilter: false, 
		bInfo: false,
		// language:<?php echo smgt_datatable_multi_language();?>
	});
	$('.width_200').DataTable({
		responsive: true,
		bPaginate: false,
		bFilter: false, 
		bInfo: false,
	});

	$( "#save_exam_time" ).on("click",function(e) {
		var subject_data = $("#subject_data").val();
		var suj = JSON.parse(subject_data);
		var productIds = [];
		 jQuery.each( suj, function( i, val ) {
			
			var exdt = $("#exam_date_"+val.subid).val();
			
			var strh = $("#start_time_"+val.subid).val();
			var strm = $("#start_min_"+val.subid).val();
			var strap = $("#start_ampm_"+val.subid).val();
			
			var endh = $("#end_time_"+val.subid).val();
			var endm = $("#end_min_"+val.subid).val();
			var endap = $("#end_ampm_"+val.subid).val();
			
			var exsdtfull = exdt+strh+strm+strap;
			var exedtfull = exdt+endh+endm+endap;
			
			if ($.inArray(exsdtfull, productIds) == -1) {
				productIds.push(exsdtfull);
			}
			else{
				alert("Fail! More than one subject exam date & time same.','school-mgt');?>");
				e.preventDefault(e);
			}
			if ($.inArray(exedtfull, productIds) == -1) {
				productIds.push(exedtfull);
			}
			else{
				alert("Fail! More than one subject exam date & time same.");
				e.preventDefault(e);
			}
			
			var strfull = strh+":"+strm+" "+strap;
			var endfull = endh+":"+endm+" "+endap;
			 
            var st = Converttimeformat(strfull);
            var et = Converttimeformat(endfull);
			 
            if (st >= et) {
				alert('Subject '+val.sub_name+' '+'End time must be greater than start time.');
				e.preventDefault(e);
            }
 
		});  
	});
	function Converttimeformat(strfull) {
		var hrs = Number(strfull.match(/^(\d+)/)[1]);
		var mnts = Number(strfull.match(/:(\d+)/)[1]);
		var format = strfull.match(/\s(.*)$/)[1];
		if (format == "pm" && hrs < 12) hrs = hrs + 12;
		if (format == "am" && hrs == 12) hrs = hrs - 12;
		var hours = hrs.toString();
		var minutes = mnts.toString();
		if (hrs < 10) hours = "0" + hours;
		if (mnts < 10) minutes = "0" + minutes;
		return hours + ":" + minutes;
	}

	$('#exam_timelist').DataTable({
		responsive: true,
		bPaginate: false,
		bFilter: false, 
		bInfo: false,
		// language:<?php //echo smgt_datatable_multi_language();?>
	});
	$('.exam_table').DataTable({
		responsive: true,
		bPaginate: false,
		bFilter: false, 
		bInfo: false,
	});

});